function elval = block_outerloop(b)
% Calculates the block-EL outer-loop
%
%
el_infinity = 10^100;
global el_f
global bel_block_len bel_block_shift
global bel_method

%speed up of the HEL and ET
global use_gel_speed gel_speed_conv gel_speed_mult gel_max_index
if isempty(use_gel_speed)
  use_gel_speed = 0;
end

w = el_f(b);    
if bel_block_len>1
  block_w = make_block_mc(w, bel_block_len, bel_block_shift);
else
  block_w = w;
end

if use_gel_speed
  speed_int_num = round(b*gel_speed_mult);
  if speed_int_num > gel_max_index
    speed_int_num = gel_max_index;
    gel_speed_conv(gel_max_index) = -1;
  end
  if speed_int_num < 1
    speed_int_num = 1;
    gel_speed_conv(1) = -1;
  end
end

ec = 0; %by default
lower_bel_method = lower(bel_method);
if strcmp(lower_bel_method,'el')
  [elval,ec] = innerloop_EL(block_w);
  if use_gel_speed
    gel_speed_conv(speed_int_num)=ec;
  end
else
  if use_gel_speed
    calculate_gel = gel_speed_conv(speed_int_num)~=0; %if its '1', then EL converged                                    
                                                      %if its '-1', then we
                                                      %have no information
                                                      %about convergence
  else
    calculate_gel = 1;
  end

  if calculate_gel
    switch lower(bel_method)
      case 'mhde'
         [elval,ec] = innerloop_HEL_disp(block_w);
      case 'et'
         [elval,ec] = innerloop_ET_disp(block_w);
      otherwise
         error('BEL ERROR: unknown method ''%s''',bel_method);
    end
  end
end

if ec == 0
    elval = el_infinity;
end 

end
