function w = hh_mc(theta);
% Moment condition function for Hall-Horowitz model
%
% Moment condition function for Hall-Horowitz model
% Takes data from global hh_x and hh_z
    
global hh_x hh_z;
u = exp(-0.72 - theta*(hh_x + hh_z) + 3*hh_z)  - 1;
uz = u .* hh_z;
w = [u uz];
