function b_res = line_grid_binary_min_search(func, left, right, numpoints, delta)

%first we do grid search
numgrid = left:delta:right;

step = (right-left)/(numpoints-1);
numgrid = left:step:right;

best_val = func(left);
best_b = left;

for i=2:length(numgrid)
  b = numgrid(i);
  f_val = func(b);
  if f_val<best_val
    best_val = f_val;
    best_b = b;
  end
end

if abs(best_b-left)<0.0001
  b_res = left; %boundary solution on the left bound
  return
end

if abs(best_b-right)<0.0001
  b_res = right; %boundary solution on the left bound
  return
end

%not a boundaty solution
cur_val = best_val;
cur_b = best_b;


valL = func(cur_b-delta/2);
change = cur_val-valL;

if change>=0
  left = cur_b - step; right = cur_b;
else
  left = cur_b; right = cur_b + step;
end

while right-left>delta
  new_b = (right+left)/2;
  new_val = func(new_b);
  valL = func(new_b-delta/2);
  change = new_val-valL;

  if change>=0
    right = new_b-delta/2;
  else
    left = new_b;
  end
end

b_res = (right+left)/2;
