function  sim_hh_block_master_fn( folder_name, reps, numpoints, from_p, to_p )
% Example of use:
% sim_hh_block_master_fn( 'out', 1000, 64, 1, 32 );

if from_p>to_p || to_p>numpoints
  error('problem');
end

rand('twister', sum(100*clock)); %initialize the random numbers generator

for p_i=from_p:to_p
  alpha = 2*pi()*(p_i-1)/numpoints;
  misspec_sd = 0.1*sin(alpha);
  misspec_corr = 0.1*sqrt(2)*cos(alpha);
  disp(sprintf('Misspec a=%1.2f, %2.0f/%1.0f, ms_sd = %1.2f, ms_rho = %1.2f', ...
          alpha, p_i, numpoints, misspec_sd, misspec_corr));
  slave_file_name = [folder_name '\hh_polar' int2str(p_i) '.mat'];
  sim_hh_block_slave
end


